Codeforces Round #633 (Div. 2)

Solutions


A. Filling Diamonds

通过猜测就欧克了。
发现如果竖直放置就只有一种摆放方法了。

#include
using namespace std;
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define sz(x) ((int)(x).size())
typedef vector VI;
typedef pair PII;
const int N=100010;
const int inf=0X3f3f3f3f;
const long long INF=0x3f3f3f3f3f3f3f3f;
const double eps=1e-6;
const double pi=acos(-1.0);
const int mod=1000000007;
typedef long long ll;
ll powmod(ll a,ll b) {ll res=1;a%=mod; assert(b>=0); for(;b;b>>=1){if(b&1)res=res*a%mod;a=a*a%mod;}return res;}
ll gcd(ll a,ll b) { return b?gcd(b,a%b):a;}
// head
int _;
int main() {
	for (scanf("%d",&_);_;_--) {
		int n;
		scanf("%d",&n);
		printf("%d\n",n);
	}
}

B. Sorted Adjacent Differences

排序后,比较显然的就相距最远的放右边,然后就这样放就可以了。

#include
using namespace std;
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define sz(x) ((int)(x).size())
typedef vector VI;
typedef pair PII;
const int N=100010;
const int inf=0X3f3f3f3f;
const long long INF=0x3f3f3f3f3f3f3f3f;
const double eps=1e-6;
const double pi=acos(-1.0);
const int mod=1000000007;
typedef long long ll;
ll powmod(ll a,ll b) {ll res=1;a%=mod; assert(b>=0); for(;b;b>>=1){if(b&1)res=res*a%mod;a=a*a%mod;}return res;}
ll gcd(ll a,ll b) { return b?gcd(b,a%b):a;}
// head
int _;
int main() {
	for (scanf("%d",&_);_;_--) {
		int n;
		scanf("%d",&n);
		VI t(n);
		for (int i=0;i=0) {
			printf("%d %d ",t[r++],t[l--]);
		}
		puts("");
	}
}

C. Powered Addition

这个题稍加分析,可以发现,你只要确定逆序的最大差值即可,然后计算秒数,这样的话,任意位置总是可以满足要求的。

#include
using namespace std;
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define sz(x) ((int)(x).size())
typedef vector VI;
typedef pair PII;
const int N=100010;
const int inf=0X3f3f3f3f;
const long long INF=0x3f3f3f3f3f3f3f3f;
const double eps=1e-6;
const double pi=acos(-1.0);
const int mod=1000000007;
typedef long long ll;
ll powmod(ll a,ll b) {ll res=1;a%=mod; assert(b>=0); for(;b;b>>=1){if(b&1)res=res*a%mod;a=a*a%mod;}return res;}
ll gcd(ll a,ll b) { return b?gcd(b,a%b):a;}
// head
int _;
int main() {
	for (scanf("%d",&_);_;_--) {
		int n;
		scanf("%d",&n);
		VI a(n),d(n);
		for (int i=0;i0);
			printf("%d\n",cnt);
		}
	}
}

D. Edge Weight Assignment

这道题分析了挺久的,如果路径都是偶数,那么最小肯定是1,如果存在奇数的话,最小肯定是3。接下来就是最大的情况了,我一开始以为和直径有关,后来发现越来越离谱。只需要统计非叶子节点连接多少个叶子节点即可,这些边的边权都要一致才可以,然后就解决了。这样就是纯属猜测了。

正解就是通过一种方法可以最大化结果,然后就可以知道上述猜测的正确性了。也就是在图中非叶子节点上又多了叶子,那么就要和原来的那个叶子的边权一致。见官方图

Codeforces Round #633 (Div. 2)_第1张图片

#include
using namespace std;
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define sz(x) ((int)(x).size())
typedef vector VI;
typedef pair PII;
const int N=100010;
const int inf=0X3f3f3f3f;
const long long INF=0x3f3f3f3f3f3f3f3f;
const double eps=1e-6;
const double pi=acos(-1.0);
const int mod=1000000007;
typedef long long ll;
ll powmod(ll a,ll b) {ll res=1;a%=mod; assert(b>=0); for(;b;b>>=1){if(b&1)res=res*a%mod;a=a*a%mod;}return res;}
ll gcd(ll a,ll b) { return b?gcd(b,a%b):a;}
// head
int n;
vector G[N];
bool isleaf[N];
int dep[N];
bool flag;
void dfs(int u,int p) {
	dep[u]=dep[p]+1;
	for (auto it:G[u]) {
		if (it!=p) {
			dfs(it,u);
		}
	}
}
int main() {
	scanf("%d",&n);
	for (int i=0;i

你可能感兴趣的:(Codeforces Round #633 (Div. 2))